(function() {
  var encoding, request, requestParser;

  request = require('superagent');

  encoding = require('encoding');

  requestParser = function(res, done) {
    res.text = '';
    res.setEncoding('binary');
    res.on('data', function(chunk) {
      return res.text += chunk;
    });
    return res.on('end', function() {
      return done(null, {
        byteLength: Buffer.byteLength(res.text, 'binary'),
        text: exports.convertToUtf8(res.text)
      });
    });
  };

  exports.requestGet = function(url) {
    return request.get(url).parse(requestParser).set({
      'User-Agent': 'Monazilla/1.00 (node-2ch)'
    });
  };

  exports.convertToUtf8 = function(cp932) {
    return encoding.convert(cp932, 'utf-8', 'cp932').toString();
  };

  exports.escapeRegExpChars = function(str) {
    return str.replace(/([.?*+^$[\]\\(){}|-])/g, "\\$1");
  };

}).call(this);
